<template>
  <form @submit.prevent="submitForm" >
    <div class="form-group" :class="{invalid: !firstName.isValid}">
      <label for="firstname">Firstname</label>
      <input
          class="form-control"
        type="text"
        id="firstname"
        v-model.trim="firstName.val"
        @blur="clearValidity('firstName')"
      />
      <p v-if="!firstName.isValid">Firstname must not be empty.</p>
    </div>
    <div class="form-group" :class="{invalid: !lastName.isValid}">
      <label for="lastname">Lastname</label>
      <input
          class="form-control"
        type="text"
        id="lastname"
        v-model.trim="lastName.val"
        @blur="clearValidity('lastName')"
      />
      <p v-if="!lastName.isValid">Lastname must not be empty.</p>
    </div>
    <div class="form-group" :class="{invalid: !description.isValid}">
      <label for="description">Description</label>
      <textarea
          class="form-control"
        id="description"
        rows="5"
        v-model.trim="description.val"
        @blur="clearValidity('description')"
      ></textarea>
      <p v-if="!description.isValid">Description must not be empty.</p>
    </div>
    <div class="form-group" :class="{invalid: !rate.isValid}">
      <label for="rate">Hourly Rate</label>
      <input class="form-control" type="number" id="rate" v-model.number="rate.val" @blur="clearValidity('rate')" />
      <p v-if="!rate.isValid">Rate must be greater than 0.</p>
    </div>
    <div class="form-group" :class="{invalid: !category.isValid}">
      <h3>category of Expertise</h3>
      <div>
        <input
            class="form-control"
          type="checkbox"
          id="frontend"
          value="frontend"
          v-model="category.val"
          @blur="clearValidity('category')"
        />
        <label for="frontend">Frontend Development</label>
      </div>
      <div class="form-control">
        <input
          type="checkbox"
          id="backend"
          value="backend"
          v-model="category.val"
          @blur="clearValidity('category')"
        />
        <label for="backend">Backend Development</label>
      </div>
      <div class="form-group">
        <input
          type="checkbox"
          id="career"
          value="career"
          v-model="category.val"
          @blur="clearValidity('category')"
        />
        <label for="career">Career Advisory</label>
      </div>
      <p v-if="!category.isValid">At least one expertise must be selected.</p>
    </div>
    <p v-if="!formIsValid">Please fix the above errors and submit again.</p>
    <base-button>Register</base-button>
  </form>
</template>

<script>
export default {
  emits: ['save-data'],
  data() {
    return {
      firstName: {
        val: '',
        isValid: true,
      },
      lastName: {
        val: '',
        isValid: true,
      },
      description: {
        val: '',
        isValid: true,
      },
      rate: {
        val: null,
        isValid: true,
      },
      category: {
        val: [],
        isValid: true,
      },
      formIsValid: true,
    };
  },
  methods: {
    clearValidity(input) {
      this[input].isValid = true;
    },
    validateForm() {
      this.formIsValid = true;
      if (this.firstName.val === '') {
        this.firstName.isValid = false;
        this.formIsValid = false;
      }
      if (this.lastName.val === '') {
        this.lastName.isValid = false;
        this.formIsValid = false;
      }
      if (this.description.val === '') {
        this.description.isValid = false;
        this.formIsValid = false;
      }
      if (!this.rate.val || this.rate.val < 0) {
        this.rate.isValid = false;
        this.formIsValid = false;
      }
      if (this.category.val.length === 0) {
        this.category.isValid = false;
        this.formIsValid = false;
      }
    },
    submitForm() {
      this.validateForm();

      if (!this.formIsValid) {
        return;
      }

      const formData = {
        first: this.firstName.val,
        last: this.lastName.val,
        desc: this.description.val,
        rate: this.rate.val,
        category: this.category.val,
      };

      this.$emit('save-data', formData);
    },
  },
};
</script>

<style scoped>

</style>